;***************************************************************************;
;                               M A C R O . I N C                           ;
;===========================================================================;
;       Commonly used macros to be included in assembly language routines.  ;
;***************************************************************************;

;===============================================================
; Macro:        =*=SaveRegs=*=
;---------------------------------------------------------------
; Task:         Save registers on stack.
; Input:        Registers to save (enclosed in <and>).
; Output:       none
; Registers:    none
; Note:         Registers are saved in the order listed.
;===============================================================
MACRO   SaveRegs        registers
  IRP   reg, <registers>        ;; Uses IRP to save list of regs on stack.
        push    reg             ;; Save register on stack.
 ENDM
ENDM    SaveRegs
;...............................................................

;===============================================================
; Macro:        =*=RestoreRegs=*=
;---------------------------------------------------------------
; Task:         Restore registers saved on stack.
; Input:        Registers to save.
; Output:       none
; Registers:    none
; Note:         Registers are restored in the order listed.
;               Registers must be restored in the opposite order
;               they are saved.
;===============================================================
MACRO   RestoreRegs     registers
  IRP   reg, <registers>        ;; Uses IRP directive to pop registers.
        pop    reg
  ENDM
ENDM    RestoreRegs
;...............................................................
